// This file is required by the index.html file and will
// be executed in the renderer process for that window.
// No Node.js APIs are available in this process because
// `nodeIntegration` is turned off. Use `preload.js` to
// selectively enable features needed in the rendering
// process.
const btn = document.getElementById('btn')
const btnSet = document.getElementById('btn-set')
const filePathElement = document.getElementById('filePath')

btnSet.addEventListener('click', async () => {
  window.electronAPI.apiSetSchemas([{
    active: true,
    name: "工商图谱",
    database: "default",
    pageSize: 10,
    nodes: [
      { id: 1, name: '公司', path: 'company', color: '#E34649', size: 0, imgProp: '', labels: ['company'], properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '公司名称', key: 'name', valType: 'string', searchAble: true, order: 0 }, { name: '注册资金（万元）', key: 'capital', valType: 'number', order: 1 }, { name: '创建年份', key: 'create_date', valType: 'datetime', order: 2 }, { name: '公司网站', key: 'home_page', valType: 'url', order: 3 }, { name: '公司LOGO', key: 'logo', valType: 'img', order: 4 }, { name: '备注', key: 'remark', valType: 'string', searchAble: true }] },
      { id: 2, name: '投资公司', color: '#C28C3C', size: 0, imgProp: '', path: 'investment', labels: ['investment'], properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '公司名称', key: 'name', valType: 'string', searchAble: true }, { name: '备注', key: 'remark', valType: 'string', searchAble: true }] },
      { id: 3, name: '人员', color: '#134649', size: 0, imgProp: '', path: 'staff', labels: ['staff'], properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '姓名', key: 'name', valType: 'string', searchAble: true, order: 0 }, { name: '性别', key: 'sex', valType: 'select', options: [{ name: '男', val: '男' }, { name: '女', val: '女' }] }, { name: '手机号', key: 'phone_num', valType: 'string', searchAble: true, order: 1 }, { name: '出生日期', key: 'birthday', valType: 'datetime', searchAble: true, order: 2 }, { name: '连接', key: 'person_url', valType: 'url', order: 3 }, { name: '备注', key: 'remark', valType: 'string', searchAble: true }] },
      { id: 4, name: '项目', color: '#205892', size: 0, imgProp: '', path: 'project', labels: ['project'], properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '项目名称', key: 'name', valType: 'string', searchAble: true }, { name: '立项时间', key: 'create_time', valType: 'datetime', searchAble: true }, { name: '连接', key: 'project_url', valType: 'url' }, { name: '备注', key: 'remark', valType: 'string', searchAble: true }] },
    ],
    links: [
      { id: 1, name: '投资', hid: 2, tid: 1, type: 'INVEST', properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '投资额度（万元）', key: 'quota', valType: 'number', searchAble: true }, { name: '投资时间', key: 'invest_time', valType: 'datetime', searchAble: true }] },
      { id: 2, name: '任职公司', hid: 3, tid: 1, type: 'WORK_FOR_COMPANY', properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '职务名称', key: 'position', valType: 'string', searchAble: true }, { name: '起始时间', key: 'start_time', valType: 'datetime', searchAble: true },] },
      { id: 3, name: '任职投资', hid: 3, tid: 2, type: 'WORK_FOR_INVESTMENT', properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '职务名称', key: 'position', valType: 'string', searchAble: true }, { name: '起始时间', key: 'start_time', valType: 'datetime', searchAble: true },] },
      { id: 4, name: '任职项目', hid: 3, tid: 4, type: 'WORK_FOR_PROJECT', properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '职务名称', key: 'position', valType: 'string', searchAble: true }, { name: '起始时间', key: 'start_time', valType: 'datetime', searchAble: true },] },
      { id: 5, name: '参与', hid: 1, tid: 4, type: 'TAKE_IN', properties: [{ name: 'id', key: 'id', valType: 'string' }, { name: '参与内容', key: 'job', valType: 'string', searchAble: true }, { name: '起始时间', key: 'start_time', valType: 'datetime', searchAble: true }, { name: '分包合同额度（万元）', key: 'quota', valType: 'number', searchAble: true },] },
    ],
    defaultQuery: { cypher: 'MATCH (N1)-[R1]-> (N2:company)-[R2]->(N3) RETURN N1,R1, N2,R2,N3 limit 20' },
    queries: [//定制cyhper查询
      { name: '查找投资', remark: "", cypher: 'match (n:company)-[r]-(m:investment{name:$name})  return n,r,m', properties: [{ name: '投资机构名称', key: 'name', valType: 'string', association: { nodeOrRel: 'node', label: 'investment', property: 'name' } }] },
      { name: '查找被投资', remark: "", cypher: 'match (n:company)-[r]-(m:investment)  where n.name=$name return n,r,m', properties: [{ name: '公司名称', key: 'name', valType: 'string', association: { nodeOrRel: 'node', label: 'company', property: 'name' } }] },
      { name: '查找任职', cypher: 'match (n:staff)-[r]-(m) where n.name=$name return n,r,m', properties: [{ name: '姓名', key: 'name', valType: 'string', association: { nodeOrRel: 'node', label: 'staff', property: 'name' } }] },
      { name: 'n度相关', remark: '注释：查找与某人有从“大于等于到小于等于”范围内度数关系的人、公司、投资机构、项目', cypher: 'MATCH path=(s:staff {name: $name})-[*$d1..$d2]-(m)  RETURN path', properties: [{ name: '姓名', key: 'name', valType: 'string', association: { nodeOrRel: 'node', label: 'staff', property: 'name' } }, { name: '大于等于', key: 'd1', valType: 'number' }, { name: '小于等于', key: 'd2', valType: 'number' }] },
      { name: '引荐人', remark: '找到人脉途径将第一人引荐给第二人', cypher: 'MATCH (tom:staff {name: $name1})-[act1]->(m)<-[act2]-(coActors), (coActors)-[act3]->(m2)<-[act4]-(cruise:staff {name: $name2})  RETURN tom,act1, m,act2, coActors,act3, m2,act4, cruise', properties: [{ name: '第一人', key: 'name1', valType: 'string', association: { nodeOrRel: 'node', label: 'staff', property: 'name' } }, { name: '第二人', key: 'name2', valType: 'string', association: { nodeOrRel: 'node', label: 'staff', property: 'name' } }] },
    ]
  }])
})

btn.addEventListener('click', async () => {
  const obj = await window.electronAPI.apiGetSchemas()
  console.log(obj);
  filePathElement.innerText = obj
})